/***************************************/
/*			Oil Panic V 1.0			   */
/*	(c) Oct. 2001 Martin Bergmann	   */
/* http://stud3.tuwien.ac.at/~e9527180 */
/* e9527180@stud3.tuwien.ac.at		   */
/* ----------------------------------- */
/* This souce is free, open and		   */
/* whatever. Use it on your own risk   */
/* Only for non-commerical purposes	   */
/***************************************/
import java.awt.*;					
import java.awt.event.*;
import java.applet.*;
import java.awt.Toolkit;
import java.net.URL;
import java.awt.image.*;

public class OilPanic extends Applet implements Runnable 
{
	private final static String host="http://members.chello.at/bergmann.martin/OilPanic";
    private int x = 4;			// Position of our hero
	private byte missed=0;		// Amount of missed drops
	private byte saved=0;		// Amount of drops in can
	private int score=0;		// Your score
	private int catched=0;		// Overall catched drops - need for level raise
	private int time[]={2400,2200,2000,1800,1600,1400,1200,1000,750};	// speed in levels
	private boolean paused=false;	// Game paused ?
	private boolean gameOver=false;	// Game over ?
	private boolean titel=true;		// Titel or game
	final static int PRICE=5;		// Score for one catched drop
	private int titelmove=0;		// counter for titel scroller

	Thread myThread;
	MediaTracker tracker;
	Image offscreenImg;				// double buffer image
    Graphics offscreenG;			
	// all kinds of loaded images
	Image backgroundImage,leftemptyImage,rightemptyImage,tropfenImage,tonneImage,titelImage;
	Image backImage;					// background image
	Image runImage[] = new Image[2];	// the two running frames
	Graphics backG;

	// array for the falling drops
	public byte area[][]={{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0}};
	Timer dropTimer;
	
    public void init() 
	{
		// First load all Images ...
		tracker = new MediaTracker(this);
		backgroundImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/wellback.gif");
		tracker.addImage(backgroundImage, 1);
		runImage[0] = Toolkit.getDefaultToolkit().getImage(host+"/gfx/left.gif");
		tracker.addImage(runImage[0], 2);
		runImage[1] = Toolkit.getDefaultToolkit().getImage(host+"/gfx/right.gif");
		tracker.addImage(runImage[1], 3);
		leftemptyImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/leftempty.gif");
		tracker.addImage(leftemptyImage, 4);
		rightemptyImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/rightempty.gif");
		tracker.addImage(rightemptyImage, 5);
		tropfenImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/tropfen.gif");
		tracker.addImage(tropfenImage, 6);
		tonneImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/tonne.gif");
		tracker.addImage(tonneImage, 7);
		titelImage = Toolkit.getDefaultToolkit().getImage(host+"/gfx/titel.gif");
		tracker.addImage(titelImage, 8);

		// .. and wait until loading is finished
		try
		{
			tracker.waitForAll();
		}
		catch (Exception e)
		{
			System.out.println("MediaTracker:"+e);
		}

		backImage = createImage(240, 320);				// Background Image
        backG = backImage.getGraphics();				// Graphics object Background Image
		createBack();									// Create Background (draw background, barrels, ...)

		offscreenImg = createImage(240, 320);			// Image for double buffering
        offscreenG = offscreenImg.getGraphics();		// Graphics object for double Buffering

		addKeyListener(new KeyAdapter()					// KeyListener to recognize user input
		{
			public void keyPressed(KeyEvent e) 
			{
				processInput(e.getKeyCode());			// if key pressed - call processInput routine
			}
		});
		dropTimer= new Timer(this);						// create timer (own thread used for periodic drawing)
		dropTimer.start();
	}

    public void start() 
	{
		if (myThread == null) 
		{
			myThread = new Thread(this);
            myThread.start();
         }
    }

    public void stop() 
	{
		if (myThread != null) 
		{
			myThread.stop();
            myThread = null;
        }
	}

   public void run()
   {
   }

	public void paint(Graphics g) 
	{
		if (titel)						// Draw Titelscreen)
		{
			Font f = new Font("Times", Font.BOLD , 16);
			offscreenG.setFont(f);
			offscreenG.setColor(Color.black);
			offscreenG.drawImage(titelImage,0,0,this);		// Draw TitelImage on doubleBuffer Image
			// Draw copyright text (use sinus for cheap but nice effect) on double Buffer Image
			offscreenG.drawString("(c) 2001, Martin Bergmann",240-titelmove*2,180+(int)(Math.sin(titelmove)*10));
			titelmove++;
			if (titelmove>250) titelmove=0;
			g.drawImage(offscreenImg, 0, 0, this); 			// Draw doubleBuffer Image onto Display
		}
		else	// Game
		{
			offscreenG.drawImage(backImage,0,0,this);	// Draw background on doubleBuffer Image
			Font f = new Font("Times", Font.BOLD , 16);	// Load times-Font, bold Size is 16 pixel
			offscreenG.setFont(f);
			if (x==0) // if x=0 empty can on left side
			{
				offscreenG.drawImage(leftemptyImage,x*15+15,260,this);	// Draw empty Image
				if (saved >0) // empty content of can
				{
					score+=saved*PRICE;				// Increase score
					saved=0;						// clear can content
				}
			}
			else
			if (x==9) // if x=9 empty can on right side
			{
				offscreenG.drawImage(rightemptyImage,x*15+15,260,this); // Draw empty Image
				if (saved >0) // empty content of can
				{
					score+=saved*PRICE;				// increase score
					saved=0;						// clear can content
				}
			}
			else offscreenG.drawImage(runImage[x%2],x*15+15,260,this);  // draw running image
			for (int y=0;y<9 ;y++) // draw th oil drops
			{
				for (int x=0;x<8 ;x++) if (area[x][y]>0) offscreenG.drawImage(tropfenImage,x*15+40,y*34+10,this);
			}
			offscreenG.setColor(Color.yellow);	// change color to yellow
			offscreenG.drawString("Money: "+score+"$",20,314); // draw score
			offscreenG.drawString("Missed: "+missed,150,314); // draw missed drops
			offscreenG.setColor(Color.black);
			offscreenG.fillRect(206,50-saved*10,18,saved*10);	// draw content of can	

			if (isPaused())	// if game is paused draw 'Paused!'
			{
				f = new Font("Times", Font.BOLD, 32);
				offscreenG.setFont(f);	
				offscreenG.setColor(Color.yellow);
				offscreenG.drawString("Paused!",40,160);
			}
			if (isGameOver()) // if game is over draw 'game over'
			{
				f = new Font("Times", Font.BOLD, 38);
				offscreenG.setFont(f);
				offscreenG.setColor(Color.green);
				offscreenG.drawString("Game Over!",10,150);
				f = new Font("Times", Font.BOLD, 12);
				offscreenG.setFont(f);
				offscreenG.drawString("Press Space",50,180);
			}
			g.drawImage(offscreenImg, 0, 0, this);	// copy doubleBuffer Image to display
		}
	}

	public void update(Graphics g) 
	{
		paint(g);
	}

	private void createBack()
	{
		backG.drawImage(backgroundImage,0,0,this);
		backG.drawImage(tonneImage,170,275,this);	// draw left barrel
		backG.drawImage(tonneImage,0,275,this);	// draw right barrel
		backG.setColor(Color.blue);
		backG.fill3DRect(190, 0, 60, 60, true); // blue info rectangele (right, top)
		backG.setColor(Color.yellow);			// draw the can into info panel
		backG.drawLine(205,50,225,50);
		backG.drawLine(205,50,205,20);
		backG.drawLine(225,50,225,20);
	}
	
	private void processInput(int keyCode)
	{
		if (titel)	// Titel: Press any key to continue
		{
			titel=!titel;
			initValues();	// Initialize all game variables
			repaint();
		}
		else	// Game
		{
			switch (keyCode)
			{
				case 37 :	//left
					if ((!isPaused())&&(!isGameOver()))
					{
						if (x>0) x--;	// if possible move left
						repaint();
					}
					break;
				case 39 :	//right
					if ((!isPaused())&&(!isGameOver()))
					{
						if (x<9) x++;	// if possible move right
						repaint();
					}
					break;
				case 32 :	//space
					if (isGameOver()) //GameOver->space->Titelscreen
					{
						titel=true;
					}
					else	// unpause game
					{
						paused=!paused;
					}
					repaint();
					break;
			}
		}
	}

	/**********************************************/
	/* Initialize all variables to start new game */
	/**********************************************/
	private void initValues()
	{
		score=0;
		x=4;
		missed=0;
		saved=0;
		catched=0;
		titelmove=0;
		gameOver=false;
		//Init the drop array
		for (int row=0;row<8 ;row++ )
		{
			for (int col=0;col<8 ;col++ )
			{
				area[col][row]=0;
			}
		}
	}
	/***********************/
	/* Get player position */
	/***********************/
	public int getXPos()
	{
		return x-1;
	}
	/*************************/
	/* player catched a drop */
	/*************************/
	public void incSaved()
	{
		catched++;
		if (saved<3)
		{
			saved++;
		}
		else incMissed();		// Can is already full of oil
	}
	/************************/
	/* player missed a drop */
	/************************/
	public void incMissed()
	{
		if (missed<3)
		{
			missed++;
		}
		else gameOver=true;		// Too much misses -> Game Over
	}
	/***************************/
	/* check if game is paused */
	/***************************/
	public boolean isPaused()
	{
		return paused;
	}
	/**********************/
	/* check if game over */
	/**********************/
	public boolean isGameOver()
	{
		return gameOver;
	}
	/**********************/
	/* titel or game mode */
	/**********************/
	public boolean isTitel()
	{
		return titel;
	}
	/************************************/
	/* get time delay for falling drops */
	/************************************/
	public int getTime()
	{
		int level=catched / 10;		// calculate level
		if (level>(time.length-1)) level=time.length-1;
		return time[level];
	}
}